<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="专家姓名" prop="expertName">
              <el-input v-model="queryParams.expertName" placeholder="请输入推荐专家姓名" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="手机号" prop="expertPhone">
              <el-input v-model="queryParams.expertPhone" placeholder="请输入专家手机号" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="状态" prop="status">
              <el-select v-model="queryParams.status" placeholder="请选择审批状态" clearable>
                <el-option v-for="dict in expert_status" v-show="dict.value !== '0'" :key="dict.value" :label="dict.label" :value="dict.value" />
              </el-select>
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
     <template #header>
       <el-row :gutter="10" class="mb8">
         <el-col :span="1.5">
           <el-button type="primary" plain icon="Plus" @click="handleAdd">新增</el-button>
         </el-col>

         <!-- <el-col :span="1.5">
           <el-button v-hasPermi="['expert:expertRecommend:export']" type="warning" plain icon="Download" @click="handleExport">导出</el-button>
         </el-col> -->
         <right-toolbar v-model:showSearch="showSearch" @query-table="getList"></right-toolbar>
       </el-row>
     </template>

      <el-table v-loading="loading" :data="expertRecommendList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column type="index" label="序号" width="50" align="center">
          <template #default="scope">
            <span>{{
                (queryParams.pageNum - 1) * queryParams.pageSize + scope.$index + 1
              }}</span>
          </template>
        </el-table-column>z
        <el-table-column label="专家姓名" align="center" prop="expertName" />
        <el-table-column label="手机号" align="center" prop="expertPhone" />
        <el-table-column label="推荐理由" align="center" prop="reason" />
        <el-table-column label="状态" align="center" prop="status">
          <template #default="scope">
            <dict-tag :options="expert_status" :value="scope.row.status" />
          </template>
        </el-table-column>
        <el-table-column label="推荐时间" align="center" prop="createTime" />
        <el-table-column label="完整性校验" align="center">
          <template #default="scope">
            <el-button type="primary" size="small"  @click="handleVerify(scope.row)">校验</el-button>
          </template>
        </el-table-column>
        <!-- <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button v-hasPermi="['expert:expertRecommend:edit']" link type="primary" icon="Edit" @click="handleUpdate(scope.row)"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button
                v-hasPermi="['expert:expertRecommend:remove']"
                link
                type="primary"
                icon="Delete"
                @click="handleDelete(scope.row)"
              ></el-button>
            </el-tooltip>
          </template>
        </el-table-column> -->
      </el-table>

      <pagination v-show="total > 0" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" :total="total" @pagination="getList" />
    </el-card>
    <!-- 添加或修改专家推荐信息对话框 -->
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="500px" append-to-body>
      <el-form ref="expertRecommendFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="专家姓名" prop="expertName">
          <el-input v-model="form.expertName" placeholder="请输入推荐专家姓名"  maxlength="20"/>
        </el-form-item>
        <el-form-item label="手机号" prop="expertPhone">
          <el-input v-model="form.expertPhone" placeholder="请输入专家手机号"   maxlength="11"/>
        </el-form-item>
        <el-form-item label="推荐理由" prop="reason">
          <el-input v-model="form.reason" type="textarea" autosize placeholder="请输入推荐理由"  maxlength="200"/>
        </el-form-item>
        <!-- <el-form-item label="审批状态" prop="status">
          <el-select v-model="form.status" placeholder="请选择状态" clearable>
            <el-option key="2" label="通过" value="2" />
            <el-option key="3" label="驳回" value="3" />
          </el-select>
        </el-form-item> -->
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="ExpertRecommend" lang="ts">
import { listExpertRecommend, getExpertRecommend, delExpertRecommend, addExpertRecommend, updateExpertRecommend,listRecommendRecord } from '@/api/expert/expertRecommend';
import { ExpertRecommendVO, ExpertRecommendQuery, ExpertRecommendForm } from '@/api/expert/expertRecommend/types';
import { verifyHmac } from '@/api/project/maintain';
const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { expert_status } = toRefs<any>(proxy?.useDict('expert_status'));

const expertRecommendList = ref<ExpertRecommendVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const expertRecommendFormRef = ref<ElFormInstance>();

const router = useRouter();
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: ExpertRecommendForm = {
  id: undefined,
  expertId: undefined,
  userId: undefined,
  expertName: undefined,
  expertPhone: undefined,
  reason: undefined,
  status: undefined
};
const validatePass = (rule, value, callback) => {
  if (value === '') {
    callback(new Error('专家手机号不能为空'))
  } else {
    const pattern = /^1(3|4|5|6|7|8|9)\d{9}$/
    if (pattern.test(value)) {
      callback()
    } else {
      callback(new Error('请输入正确的手机号'))
    }
  }
}
const data = reactive<PageData<ExpertRecommendForm, ExpertRecommendQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    expertId: undefined,
    userId: undefined,
    expertName: undefined,
    expertPhone: undefined,
    reason: undefined,
    status: undefined,
    params: {}
  },
  rules: {
    expertName: [
      { required: true, message: '推荐专家姓名不能为空', trigger: 'blur' }
    ],
    expertPhone: [
      { required: true, validator: validatePass, trigger: 'blur' }
    ],
    reason: [
      { required: true, message: '推荐理由不能为空', trigger: 'blur' }
    ],
    status: [
      { required: true, message: '审批状态不能为空', trigger: 'change' }
    ]
  }
});

const { queryParams, form, rules } = toRefs(data);

import useUserStore from '@/store/modules/user';
const userStore = useUserStore();
const userId = ref(userStore.userId);
/** 查询专家推荐信息列表 */
const getList = async () => {

  loading.value = true;
  // queryParams.value.userId = userId.value;
  const res = await listRecommendRecord(queryParams.value);
  expertRecommendList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  expertRecommendFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: ExpertRecommendVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  // router.push({ path: '/expert/recommendRecord'})

  reset();
  dialog.visible = true;
  dialog.title = '添加专家推荐信息';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: ExpertRecommendVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getExpertRecommend(_id);
  Object.assign(form.value, res.data);
  form.value.status = '2';
  dialog.visible = true;
  dialog.title = '修改专家推荐信息';
};

/** 提交按钮 */
const submitForm = () => {
  expertRecommendFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
        await addExpertRecommend(form.value).finally(() => (buttonLoading.value = false));
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: ExpertRecommendVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除专家推荐信息编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delExpertRecommend(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'expert/expertRecommend/export',
    {
      ...queryParams.value
    },
    `expertRecommend_${new Date().getTime()}.xlsx`
  );
};


/**hmac校验*/
function handleVerify(row: any) {
  verifyHmac({
    bizType: 'expertRecommend',
    id: row.id,
    fields: []
  })
    .then(result => {
      if (result.match) {
        ElMessage.success('校验通过');
      } else {
        ElMessage.error(`校验失败，该信息被篡改`);
      }
    })
    .catch(err => {
      ElMessage.error('接口请求失败: ' + (err.response?.data?.msg || err.message));
    });
}
onActivated(()=>{
  getList();
})

onMounted(() => {
  getList();
});
</script>
